

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gst.Interfaces
    (     module GI.Gst.Interfaces.ChildProxy     ,
    module GI.Gst.Interfaces.Preset         ,
    module GI.Gst.Interfaces.TagSetter      ,
    module GI.Gst.Interfaces.TocSetter      ,
    module GI.Gst.Interfaces.URIHandler     ,


    ) where

import GI.Gst.Interfaces.ChildProxy
import GI.Gst.Interfaces.Preset
import GI.Gst.Interfaces.TagSetter
import GI.Gst.Interfaces.TocSetter
import GI.Gst.Interfaces.URIHandler

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gst.Types
import GI.Gst.Callbacks


