module GI.Gst.Structs.Query where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Query = Query (ForeignPtr Query)
instance BoxedObject Query where
data QueryAddAllocationMetaMethodInfo
data QueryAddAllocationParamMethodInfo
data QueryAddAllocationPoolMethodInfo
data QueryAddBufferingRangeMethodInfo
data QueryAddSchedulingModeMethodInfo
data QueryFindAllocationMetaMethodInfo
data QueryGetNAllocationMetasMethodInfo
data QueryGetNAllocationParamsMethodInfo
data QueryGetNAllocationPoolsMethodInfo
data QueryGetNBufferingRangesMethodInfo
data QueryGetNSchedulingModesMethodInfo
data QueryGetStructureMethodInfo
data QueryHasSchedulingModeMethodInfo
data QueryHasSchedulingModeWithFlagsMethodInfo
data QueryParseAcceptCapsMethodInfo
data QueryParseAcceptCapsResultMethodInfo
data QueryParseAllocationMethodInfo
data QueryParseBufferingPercentMethodInfo
data QueryParseBufferingRangeMethodInfo
data QueryParseBufferingStatsMethodInfo
data QueryParseCapsMethodInfo
data QueryParseCapsResultMethodInfo
data QueryParseContextMethodInfo
data QueryParseContextTypeMethodInfo
data QueryParseConvertMethodInfo
data QueryParseDurationMethodInfo
data QueryParseLatencyMethodInfo
data QueryParseNFormatsMethodInfo
data QueryParseNthAllocationMetaMethodInfo
data QueryParseNthAllocationParamMethodInfo
data QueryParseNthAllocationPoolMethodInfo
data QueryParseNthBufferingRangeMethodInfo
data QueryParseNthFormatMethodInfo
data QueryParseNthSchedulingModeMethodInfo
data QueryParsePositionMethodInfo
data QueryParseSchedulingMethodInfo
data QueryParseSeekingMethodInfo
data QueryParseSegmentMethodInfo
data QueryParseUriMethodInfo
data QueryParseUriRedirectionMethodInfo
data QueryParseUriRedirectionPermanentMethodInfo
data QueryRemoveNthAllocationMetaMethodInfo
data QueryRemoveNthAllocationParamMethodInfo
data QueryRemoveNthAllocationPoolMethodInfo
data QuerySetAcceptCapsResultMethodInfo
data QuerySetBufferingPercentMethodInfo
data QuerySetBufferingRangeMethodInfo
data QuerySetBufferingStatsMethodInfo
data QuerySetCapsResultMethodInfo
data QuerySetContextMethodInfo
data QuerySetConvertMethodInfo
data QuerySetDurationMethodInfo
data QuerySetFormatsvMethodInfo
data QuerySetLatencyMethodInfo
data QuerySetNthAllocationParamMethodInfo
data QuerySetNthAllocationPoolMethodInfo
data QuerySetPositionMethodInfo
data QuerySetSchedulingMethodInfo
data QuerySetSeekingMethodInfo
data QuerySetSegmentMethodInfo
data QuerySetUriMethodInfo
data QuerySetUriRedirectionMethodInfo
data QuerySetUriRedirectionPermanentMethodInfo
data QueryWritableStructureMethodInfo
